﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections;

namespace DPTesting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Random m_Rand = new Random();
        List<ParentObject> m_Items = new List<ParentObject>();

        public ICollectionView View
        {
            get { return (ICollectionView)GetValue(ViewProperty); }
            set { SetValue(ViewProperty, value); }
        }

        // Using a DependencyProperty as the backing store for View.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ViewProperty =
            DependencyProperty.Register("View", typeof(ICollectionView), typeof(MainWindow), new UIPropertyMetadata(null));

        public MainWindow()
        {
            InitializeComponent();

            while (m_Items.Count < 20)
            {
                ParentObject obj = new ParentObject();
                m_Items.Add(obj);

                obj.Child.Value = m_Rand.Next();
            }

            View = CollectionViewSource.GetDefaultView(m_Items);
        }

        private void IncrementAndRefresh()
        {
            foreach (ParentObject parent in m_Items)
            {
                parent.Child.Value = m_Rand.Next();
            }

            View.Refresh();
        }

        private void btn_Click(object sender, RoutedEventArgs e)
        {
            IncrementAndRefresh();
        }
    }

    public class ParentObject
    {
        public SubObject Child { get; private set; }

        public ParentObject()
        {
            Child = new SubObject();
        }
    }

    public class SubObject : IComparable
    {
        public double Value { get; set; }

        public override string ToString()
        {
            return Value.ToString();
        }

        public int CompareTo(object obj)
        {
            if (obj == null || !(obj is SubObject))
                return 1;

            return Value.CompareTo(((SubObject)obj).Value);
        }
    }
}
